#include <extdll.h>			// always
#include <meta_api.h>		// of course
#include <dllapi.h>
#include "sdk_util.h"		// UTIL_LogPrintf, etc
#include <h_export.h>
#include "plugin.h"
#include "cbase.h"
#include <usercmd.h>
#include <pm_defs.h>

enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;


cvar_t nsa_armory_giveshp				   = {"nsa_armory_giveshp",	      "1",				   FCVAR_SERVER};
cvar_t nsa_armory_resources				   = {"nsa_armory_resources",	  "1",				   FCVAR_SERVER};
cvar_t nsa_armory_maxhealth				   = {"nsa_armory_maxhealth",	  "1200",			   FCVAR_SERVER};


float NextEntityCheck = 0;

int DispatchSpawn( edict_t *pent )
{
	if(FStrEq(STRING(pent->v.classname), "worldspawn"))
	{
		PRECACHE_SOUND("buttons/button2.wav");
		PRECACHE_SOUND("items/health.wav");
		PRECACHE_MODEL("sprites/laserbeam.spr");

		NextEntityCheck = 0;// OMG IM A FUCKING MORON... NO WONDER IT DIDNT WORK AFTER MAP CHANGE. (Btw, Made the SAME problem with the playerinfo plugin). /me slaps self.
	}
	RETURN_META_VALUE(MRES_HANDLED,0);
}

void StartFrame(void)
{
	if(NextEntityCheck < gpGlobals->time)
	{
		CBaseEntity *pArmory = NULL;
		while(pArmory = UTIL_FindEntityByClassname(pArmory, "team_armory"))
		{
			if(!pArmory->pev->nextthink)
			{
				pArmory->pev->nextthink = gpGlobals->time + 0.1;
			}
		}
		NextEntityCheck = gpGlobals->time + 0.25;
	}
	RETURN_META(MRES_IGNORED);
}

void DispatchThink( edict_t *pent )
{
	if(FStrEq(STRING(pent->v.classname), "team_armory") 
		||	FStrEq(STRING(pent->v.classname), "team_advarmory"))
	{
		if(CVAR_GET_FLOAT("nsa_armory_giveshp") && !pent->v.iuser1)
		{
			MedArmorySpawn(pent);
			pent->v.iuser1 = 1;
		}
		else if (!CVAR_GET_FLOAT("nsa_armory_giveshp"))
		{
			pent->v.iuser1 = 0;
		}
	}
	else if(FStrEq(STRING(pent->v.classname), "nsa_medarmory"))
	{
		MedArmoryThink(pent);
	}
	RETURN_META(MRES_IGNORED);
}

void MedArmorySpawn(edict_t *pEntity)
{
	edict_t *pMedArmory;
	pMedArmory = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
	MDLL_Spawn(pMedArmory);
	pMedArmory->v.classname = MAKE_STRING("nsa_medarmory");
	pMedArmory->v.owner = pEntity;
	pMedArmory->v.movetype = MOVETYPE_NOCLIP; 
	pMedArmory->v.iuser1 = (int)CVAR_GET_FLOAT("nsa_armory_maxhealth");//Start it up with full health.
	pMedArmory->v.solid = SOLID_BBOX;
	SET_MODEL(pMedArmory, "models/w_health.mdl");
	SET_SIZE(pMedArmory, Vector(-12, -12, -12), Vector(12, 12, 12));
	pMedArmory->v.fuser3 = gpGlobals->time + 0.1; //This is our "nextthink" because the real nextthink HAS to be called every frame for out spinny medpack h4x.
	pMedArmory->v.nextthink = gpGlobals->time;
}

void MedArmoryThink(edict_t *pMedArmory)
{
	if(pMedArmory->v.fuser3 < gpGlobals->time)
	{
		if(FNullEnt(pMedArmory->v.owner) || pMedArmory->v.owner->v.health <= 0)
		{
			REMOVE_ENTITY(pMedArmory);
			return;
		}
		
		if(pMedArmory->v.owner->v.health < 600 || !UTIL_IsBuilt(pMedArmory->v.owner))//Its not built yet, or it is damaged a lot. So hide the medpack and make it non-useable.
		{
			pMedArmory->v.effects |= EF_NODRAW;
			pMedArmory->v.solid = SOLID_NOT;
			pMedArmory->v.nextthink = gpGlobals->time + 0.1;
			return;
		}
		else
		{
			if(CVAR_GET_FLOAT("nsa_armory_resources"))
				pMedArmory->v.iuser3 = 1;
			else
				pMedArmory->v.iuser3 = 0;
			
			if(!CVAR_GET_FLOAT("nsa_armory_giveshp"))
			{
				REMOVE_ENTITY(pMedArmory);
				return;
			}
			

			CBaseEntity *pCPlayer = NULL;
			while(pCPlayer = UTIL_FindEntityByClassname(pCPlayer, "player"))
			{	
				if((pCPlayer->pev->origin - pMedArmory->v.origin).LengthSquared() < (5184))
				{
					if(pCPlayer->pev->team == pMedArmory->v.owner->v.team && pCPlayer->pev->button & IN_USE && IsAlive(pCPlayer->edict()))
					{
						MedArmoryUse(pMedArmory, pCPlayer->edict());
					}
				}
			}
			
			bool HealthFound = false;
			
			if(CVAR_GET_FLOAT("nsa_armory_resources") && pMedArmory->v.iuser1 <= (int)CVAR_GET_FLOAT("nsa_armory_maxhealth")-50)
			{
				CBaseEntity *pHealth = NULL;
				while(pHealth = UTIL_FindEntityByClassname(pHealth, "item_health"))
				{	
					if((pHealth->pev->origin - pMedArmory->v.origin).LengthSquared() < (128*128) && pHealth->pev->flags & FL_ONGROUND)
					{
						pHealth->pev->flags |= FL_KILLME;
						HealthFound = true;
						break;
					}
				}
				if(HealthFound)
				{
					EMIT_SOUND(pMedArmory, CHAN_BODY, "items/health.wav", 1, ATTN_NORM);
					pMedArmory->v.iuser1 += 50;
					PLAYBACK_EVENT_FULL( 0, pMedArmory, 47, 0, (float *)(&(pMedArmory->v.origin)), (float *)&Vector(0,0,0), 1.0, 0.0, (int)50, 0, 0, 0 ); 
					
					MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY);//MSG_BROADCAST so commander see's it. (I dont think commander will see if its not MSG_BROADCAST)
					WRITE_BYTE( TE_BEAMTORUS );
					WRITE_COORD(pMedArmory->v.owner->v.origin.x);
					WRITE_COORD(pMedArmory->v.owner->v.origin.y);
					WRITE_COORD(pMedArmory->v.owner->v.origin.z + 5);
					WRITE_COORD(pMedArmory->v.owner->v.origin.x);
					WRITE_COORD(pMedArmory->v.owner->v.origin.y);
					WRITE_COORD(pMedArmory->v.owner->v.origin.z + 256);
					WRITE_SHORT(PRECACHE_MODEL("sprites/laserbeam.spr"));
					WRITE_BYTE( 0 ); // startframe
					WRITE_BYTE( 0 ); // framerate
					WRITE_BYTE( 5 ); // life
					WRITE_BYTE( 1 );  // width
					WRITE_BYTE( 0 );   // noise
					WRITE_BYTE( 0 );   // r, g, b
					WRITE_BYTE( 200 );   // r, g, b
					WRITE_BYTE( 0 );   // r, g, b
					WRITE_BYTE( 255 );	// brightness
					WRITE_BYTE( 3 );		// speed
					MESSAGE_END();	
					HealthFound = false;
				}
			}
			
			// Fix a small sequence bug while we are here.
			// When a normal armory is shot by a player, its sequences somehow gets changed, and it causes a normal armory to LOOK like an advanced armory
			// This may cause confusion for the players since they will think its an Advanced Armory when its not. (well it did to me anyways :P)
			
			if(FStrEq(STRING(pMedArmory->v.owner->v.classname), "team_armory") && pMedArmory->v.owner->v.sequence != 2)
				pMedArmory->v.owner->v.sequence = 2;
			else if(FStrEq(STRING(pMedArmory->v.owner->v.classname), "team_advarmory") && pMedArmory->v.owner->v.sequence != 3)
				pMedArmory->v.owner->v.sequence = 3;

			
			pMedArmory->v.fuser2 = (pMedArmory->v.iuser1/CVAR_GET_FLOAT("nsa_armory_maxhealth") * 1000);
			pMedArmory->v.effects &= ~EF_NODRAW;
			pMedArmory->v.solid = SOLID_BBOX;
			if(pMedArmory->v.iuser1 < 4 && pMedArmory->v.renderfx != 19)
			{
				pMedArmory->v.renderfx = 19;
				pMedArmory->v.rendercolor = Vector(255,0,0);
				pMedArmory->v.renderamt = 1;
			}
			else if(pMedArmory->v.renderfx == 19 && pMedArmory->v.iuser1 >= 4)
			{
				pMedArmory->v.renderfx = 0;
				pMedArmory->v.rendercolor = Vector(0,0,0);
				pMedArmory->v.renderamt = 0;
			}
		}
		pMedArmory->v.origin = pMedArmory->v.owner->v.origin + Vector(0,0,64);//for the very rare case that they have some sort of entity mover. (I know I have one :P)
		pMedArmory->v.fuser3 = gpGlobals->time + 0.1;
	}

	if(pMedArmory->v.angles.y < 360)
		pMedArmory->v.angles.y += 4;
	else
		pMedArmory->v.angles.y = 0;

	pMedArmory->v.nextthink = gpGlobals->time;
}


void MedArmoryUse(edict_t *pMedArmory, edict_t *pPlayer)
{
	if(!(pMedArmory->v.effects & EF_NODRAW) && pMedArmory->v.fuser4 < gpGlobals->time)
	{
		if(pPlayer->v.team == pMedArmory->v.owner->v.team)
		{
			int Healed = 0;
			if(pPlayer->v.health < pPlayer->v.max_health)
			{
				if(pMedArmory->v.iuser1 >= 4 && CVAR_GET_FLOAT("nsa_armory_resources"))
				{
					if(FStrEq(STRING(pMedArmory->v.owner->v.classname), "team_advarmory"))
					{
						if(pPlayer->v.health <= 99 && pPlayer->v.health >= 96)
							pPlayer->v.health = 100;
						else
							pPlayer->v.health += 4;
						pMedArmory->v.iuser1 -= 4;
						Healed = 4;
					} 
					else 
					{
						if(pPlayer->v.health <= 98)
							pPlayer->v.health += 2;
						else
							pPlayer->v.health = 100;
						pMedArmory->v.iuser1 -= 2;
						Healed = 2;
					}
				}
				else if(!CVAR_GET_FLOAT("nsa_armory_resources")) 
				{
					if(FStrEq(STRING(pMedArmory->v.owner->v.classname), "team_advarmory"))
					{
						if(pPlayer->v.health <= 99 && pPlayer->v.health >= 96)
							pPlayer->v.health = 100;
						else
							pPlayer->v.health += 4;
						Healed = 4;
					} 
					else
					{
						if(pPlayer->v.health <= 98)
							pPlayer->v.health += 2;
						else
							pPlayer->v.health = 100;
						Healed = 2;
					}
				}
				if(Healed)
				{
					EMIT_SOUND_DYN(pPlayer, CHAN_ITEM, "buttons/button2.wav", 1, ATTN_NORM, 0, PITCH_NORM);
					if(CVAR_GET_FLOAT("nsa_armory_resources"))
						PLAYBACK_EVENT_FULL( 0, pMedArmory, 47, 0, (float *)(&(pMedArmory->v.origin)), (float *)&Vector(0,0,0), 1.0, 0.0, -(int)Healed, 1, 0, 0 ); 
					
					Healed = 0;
					
					if(FStrEq(STRING(pMedArmory->v.owner->v.classname), "team_advarmory"))
						pMedArmory->v.fuser4 = gpGlobals->time + 0.25;
					else
						pMedArmory->v.fuser4 = gpGlobals->time + 0.5;
					
				}
			}		
		}
	}
}



// Must provide at least one of these..
static META_FUNCTIONS gMetaFunctionTable = {
		NULL,			// pfnGetEntityAPI				HL SDK; called before game DLL
		NULL,			// pfnGetEntityAPI_Post			META; called after game DLL
		GetEntityAPI2,	// pfnGetEntityAPI2				HL SDK2; called before game DLL
		NULL,			// pfnGetEntityAPI2_Post		META; called after game DLL
		NULL,			// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
		NULL,			// pfnGetNewDLLFunctions_Post	META; called after game DLL
		GetEngineFunctions,			// pfnGetEngineFunctions		META; called before HL engine
		NULL,			// pfnGetEngineFunctions_Post	META; called after HL engine
};

// Description of plugin
plugin_info_t Plugin_info = {
	META_INTERFACE_VERSION,	// ifvers
		"ArmoryHeal",	// name
		"1.1",		// version
		"5/13/2003",	// date
		"voogru <voogru@voogru.com>",	// author
		"http://www.voogru.com",	// url
		"ARMORYHEAL",	// logtag
		PT_CHANGELEVEL,// (when) loadable
		PT_CHANGELEVEL,// (when) unloadable
};

// Global vars from metamod:
meta_globals_t *gpMetaGlobals;		// metamod globals
gamedll_funcs_t *gpGamedllFuncs;	// gameDLL function tables
mutil_funcs_t *gpMetaUtilFuncs;		// metamod utility functions

C_DLLEXPORT int Meta_Query(char *ifvers, plugin_info_t **pPlugInfo,	mutil_funcs_t *pMetaUtilFuncs) {
	*pPlugInfo=&Plugin_info;
	gpMetaUtilFuncs=pMetaUtilFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Attach(PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs) {
	gpMetaGlobals=pMGlobals;
	memcpy(pFunctionTable, &gMetaFunctionTable, sizeof(META_FUNCTIONS));
	gpGamedllFuncs=pGamedllFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Detach(PLUG_LOADTIME now, PL_UNLOAD_REASON reason) 
{
	return(TRUE);
}

void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals ) {
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;		

	CVAR_REGISTER(&nsa_armory_giveshp);
	CVAR_REGISTER(&nsa_armory_resources);
	CVAR_REGISTER(&nsa_armory_maxhealth);
}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) 
{
	gFunctionTable.pfnSpawn = DispatchSpawn;
	gFunctionTable.pfnThink = DispatchThink;
	gFunctionTable.pfnStartFrame = StartFrame;
	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}



enginefuncs_t meta_engfuncs;
C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) 
{
	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return(TRUE);
}


